#pragma once
#include "globals.h"
    #include "SoundPlayer.h"
enum class ItemType
{
    Folder=0,
    File,
    BinGame,
    Pop,
    Gameboy,
    Bin,
    Snd,
    Wav,
    Txt,
    Rom,
    Der,
    Bmp,
    EspFirm,
};


struct Item
{
    std::string fullPath;
    std::string displayName;
    std::string author;
    uint8_t Icon[24*12];
    size_t Size;
    bool hasIcon;
    ItemType Type;
};

class SDBrowse
{
public:
    enum class MenuState
    {
        MainMenu=0,
        SoundPlayer
    };

    SDBrowse();
    void init();
    bool update();
    void draw();
    size_t fileCount(std::string path);
    MenuState menustate=MenuState::MainMenu;
    SoundPlayer *soundplayer;
private:
    void m_drawAllItems();
    void m_drawItem(size_t num);
    void m_drawScrollbar();
    void m_loadItems();
    size_t m_beginitem=0;
    size_t m_selecteditem=0;
    size_t m_itemlistcount=0;
    size_t m_prevSelecteditem[10];
    size_t m_prevBeginitem[10];
    uint8_t m_pPrev=0;

    Item m_Items[5];
    size_t m_itemcount=0;
    bool m_redraw=true;
    std::string m_curDir;
    std::string m_movepath;
    bool m_movemode=false;

    void m_pushPrev();
    void m_pullPrev();
};
